<?php

namespace Jazzaaf\xenAntiVirus\Pub\Controller;

use XF\Mvc\ParameterBag;
use XF\Pub\Controller\AbstractController;


class xenAntiVirus extends AbstractController
{

public function actionIndex(ParameterBag $params)
	{
		// get visitor
		$visitor = \XF::visitor();
		
		// get permission
		if (!$visitor->hasPermission('jz_xenAntiVirus', 'view'))
		{
			return $this->noPermission();
		}
		
		// get options
		$options = \XF::options();	
		$filters = $this->getConversationFilterInput();
		
		$page = $this->filterPage($params->page);
		$perPage = 15;
		
 		// get attachments
 		$finder = \XF::finder('Jazzaaf\xenAntiVirus:AttachmentCheck');
       	$finder->with(['Attachment', 'Data', 'User'], true);

    	if (!empty($filters['filter_type']))
		{
			$finder->where('check_status', $filters['filter_type']);
		}
		
		if (!$options->jz_xenAntiVirus_use_in_private_messages) {
		
		$finder->where('Attachment.content_type', '<>', 'conversation_message');
		
		}
       	
            $finder->where('Attachment.unassociated', 0);        
            $finder->order('check_id', 'DESC');
            $finder->limitByPage($page, $perPage);

 		$attachmentFinder = $finder->fetch();
 
		$viewParams = [
			'attachmentFinder' => $attachmentFinder,
		    'total' => $finder->total(),
    		'page' => $page,
    		'perPage' => $perPage,
    		'filters' => $filters
		];
		
		// send to template
		return $this->view('Jazzaaf\xenAntiVirus:Index', 'jz_xenAntiVirus', $viewParams);
		
	}

	protected function getConversationFilterInput()
	{
		$filters = [];

		$input = $this->filter([
			'filter_type' => 'str'
		]);

		if ($input['filter_type'])
		{
			$filters['filter_type'] = $input['filter_type'];
		}

		
		return $filters;
	}	
	
		public function actionFilters()
	{
		$filters = $this->getConversationFilterInput();

		return $this->redirect($this->buildLink('xenantivirus', null, $filters));
	}
	
	public static function getUserName($contents, $params)
	{
//	\XF::dumpSimple($params);
	
	$user_id = $params[0];
	$finder = \XF::finder('XF:User');
	$username = $finder->where('user_id', $user_id)->fetchOne()->username;
	
	if (!$username) {
	$username = \XF::phrase('guest');
	}
	return $username;
	
	}
	
	
	public function actionMarkClean(ParameterBag $params)
	{
	
		// get visitor
		$visitor = \XF::visitor();
		$db = \XF::db();
		
		// get permission
		if (!$visitor->hasPermission('jz_xenAntiVirus', 'view'))
		{
			return $this->noPermission();
		}
		
		$check_id = $params->check_id;


		// get attachments
 		$finder = \XF::finder('Jazzaaf\xenAntiVirus:AttachmentCheck');
       	$attachment = $finder->where('check_id', $check_id)->fetchOne();

		if (!$attachment) {
		
		return $this->error(\XF::phrase('jz_xenAntiVirus_check_id_not_correct'));
		
		}
		
		if ($attachment->check_status == 'clean') {
		
		return $this->error(\XF::phrase('jz_xenAntiVirus_attachment_is_clean_already'));
		
		}
 		
		$db->query("UPDATE xf_jz_antivirus_check SET check_status = 'clean', moderator_id = " . $visitor->user_id . " WHERE check_id = " . $check_id);
				
		return $this->redirect($this->buildLink('xenantivirus'), \XF::phrase('jz_xenAntiVirus_attachment_marked_clean'));
	}
	
	
	public function actionDelete(ParameterBag $params)
	{
	
	// get visitor
		$visitor = \XF::visitor();
		$db = \XF::db();
		
		// get permission
		if (!$visitor->hasPermission('jz_xenAntiVirus', 'view'))
		{
			return $this->noPermission();
		}
		
		$check_id = $params->check_id;


		// get attachments
 		$finder = \XF::finder('Jazzaaf\xenAntiVirus:AttachmentCheck');
       	$attachmentCheck = $finder->where('check_id', $check_id)->fetchOne();
		
       	
		if (!$attachmentCheck) {
		
		return $this->error(\XF::phrase('jz_xenAntiVirus_check_id_not_correct'));
		
		}
		
		// get data_id
		$data_id = $attachmentCheck->data_id;

		// delete attachment from all tables
		$attachmentCheck->delete();
				
		// get attachment data
 		$finder = \XF::finder('XF:AttachmentData');
       	$attachmentData = $finder->where('data_id', $data_id)->fetchOne();
		$attachmentData->delete();
		
       	// get attachment
 		$finder = \XF::finder('XF:Attachment');
       	$attachment = $finder->where('data_id', $data_id)->fetchOne();
		$attachment->delete();       	
		
		// redirect to main page
		return $this->redirect($this->buildLink('xenantivirus'), \XF::phrase('jz_xenAntiVirus_attachment_deleted'));
	}
}